image: node:11.1.0
stages:
  - install
  - test
  - build
  - deploy

install-dependencies:
  stage: install
  script:
    - npm install
  artifacts:
    expire_in: 1hr
    paths:
      - node_modules/
  cache:
    paths:
      - node_modules/

test-apps:
  stage: test
  dependencies:
    - install-dependencies
  script:
    - npm run test

build-app:
  stage: build
  dependencies:
    - install-dependencies
  script:
    - npm run build
  artifacts:
    expire_in: 1hr
    paths:
      - dist/

pages:
  stage: deploy
  dependencies:
    - build-app
  script:
    - mv ./dist/* ./public/
    - echo 'Header set Access-Control-Allow-Origin "*"' >> public/.htaccess
    - echo 'Header set Access-Control-Allow-Methods "GET, POST, OPTIONS"' >> public/.htaccess
    - echo 'Header set Access-Control-Allow-Headers "Content-Type, Authorization"' >> public/.htaccess
  artifacts:
    paths:
      - public
  environment:
    name: production
  only:
    - branches
